diff --git a/cli.py b/cli.py
index ff4c7d6..e3a4161 100644
--- a/cli.py
+++ b/cli.py
@@ -398,6 +398,8 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         if self.gpgsigcheck(downloadpkgs) != 0:
             return 1
         
+        self.verbose_logger.log(yum.logginglevels.INFO_2, 
+                                self.fmtSection(_("Entering rpm code")))
         if self.conf.rpm_check_debug:
             rcd_st = time.time()
             self.verbose_logger.log(yum.logginglevels.INFO_2, 
@@ -408,7 +410,7 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                 for msg in msgs:
                     print to_utf8(msg)
     
-                return 1, [_('Please report this error in bugzilla')]
+                return 1, [_('Please report this error in %s') % self.conf.bugtracker_url]
 
             self.verbose_logger.debug('rpm_check_debug time: %0.3f' % (time.time() - rcd_st))
 
@@ -464,6 +466,8 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         resultobject = self.runTransaction(cb=cb)
 
         self.verbose_logger.debug('Transaction time: %0.3f' % (time.time() - ts_st))
+        self.verbose_logger.log(yum.logginglevels.INFO_2, 
+                                self.fmtSection(_("Leaving rpm code")))
         # close things
         self.verbose_logger.log(yum.logginglevels.INFO_1,
             self.postTransactionOutput())
@@ -519,8 +523,9 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         # always_output is a wart due to update/remove not producing the
         # same output.
         matches = self.doPackageLists(patterns=[arg], ignore_case=False)
-        if matches.installed: # Found a match so ignore
-            return
+        if (matches.installed or (not matches.available and
+                                  self.returnInstalledPackagesByDep(arg))):
+            return # Found a match so ignore
         hibeg = self.term.MODE['bold']
         hiend = self.term.MODE['normal']
         if matches.available:
@@ -657,7 +662,7 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
             return 2, [_('Package(s) to install')]
         return 0, [_('Nothing to do')]
 
-    def returnPkgLists(self, extcmds):
+    def returnPkgLists(self, extcmds, installed_available=False):
         """Returns packages lists based on arguments on the cli.returns a 
            GenericHolder instance with the following lists defined:
            available = list of packageObjects
@@ -666,18 +671,32 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
            extras = list of packageObjects
            obsoletes = tuples of packageObjects (obsoleting, installed)
            recent = list of packageObjects
+
+           installed_available = that the available package list is present
+                                 as .hidden_available when doing any of:
+                                 all/available/installed
            """
         
         special = ['available', 'installed', 'all', 'extras', 'updates', 'recent',
                    'obsoletes']
         
         pkgnarrow = 'all'
+        done_hidden_available = False
+        done_hidden_installed = False
         if len(extcmds) > 0:
-            if extcmds[0] in special:
+            if installed_available and extcmds[0] == 'installed':
+                done_hidden_available = True
+                extcmds.pop(0)
+            elif installed_available and extcmds[0] == 'available':
+                done_hidden_installed = True
+                extcmds.pop(0)
+            elif extcmds[0] in special:
                 pkgnarrow = extcmds.pop(0)
             
         ypl = self.doPackageLists(pkgnarrow=pkgnarrow, patterns=extcmds,
                                   ignore_case=True)
+        if self.conf.showdupesfromrepos:
+            ypl.available += ypl.reinstall_available
 
         # This is mostly leftover from when patterns didn't exist
         # FIXME: However when returnPackages() has already been run, we
@@ -699,6 +718,13 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         ypl.extras = _shrinklist(ypl.extras, extcmds)
         ypl.obsoletes = _shrinklist(ypl.obsoletes, extcmds)
         
+        if installed_available:
+            ypl.hidden_available = ypl.available
+            ypl.hidden_installed = ypl.installed
+        if done_hidden_available:
+            ypl.available = []
+        if done_hidden_installed:
+            ypl.installed = []
         return ypl
 
     def search(self, args):
@@ -843,8 +869,12 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         if len(userlist) > 0:
             if userlist[0] == 'hidden':
                 uservisible=0
+                userlist.pop(0)
+        if not userlist:
+            userlist = None # Match everything...
 
-        installed, available = self.doGroupLists(uservisible=uservisible)
+        installed, available = self.doGroupLists(uservisible=uservisible,
+                                                 patterns=userlist)
         
         if len(installed) > 0:
             self.verbose_logger.log(yum.logginglevels.INFO_2,
@@ -1079,6 +1109,22 @@ class YumOptionParser(OptionParser):
             if opts.showdupesfromrepos:
                 self.base.conf.showdupesfromrepos = True
 
+            if opts.color not in (None, 'auto', 'always', 'never',
+                                  'tty', 'if-tty', 'yes', 'no', 'on', 'off'):
+                raise ValueError, _("--color takes one of: auto, always, never")
+            elif opts.color is None:
+                if self.base.conf.color != 'auto':
+                    self.base.term.reinit(color=self.base.conf.color)
+            else:
+                _remap = {'tty' : 'auto', 'if-tty' : 'auto',
+                          '1' : 'always', 'true' : 'always',
+                          'yes' : 'always', 'on' : 'always',
+                          '0' : 'always', 'false' : 'always',
+                          'no' : 'never', 'off' : 'never'}
+                opts.color = _remap.get(opts.color, opts.color)
+                if opts.color != 'auto':
+                    self.base.term.reinit(color=opts.color)
+
             if opts.disableexcludes:
                 disable_excludes = self._splitArg(opts.disableexcludes)
             else:
@@ -1224,6 +1270,8 @@ class YumOptionParser(OptionParser):
                 metavar='[plugin]')
         self.add_option("--skip-broken", action="store_true", dest="skipbroken",
                 help=_("skip packages with depsolving problems"))
+        self.add_option("", "--color", dest="color", default=None, 
+                help=_("control whether color is used"))
 
 
         
